<?php
/*  cms-db  Copyright (C) 2007-2009 Jan Hoffmann
    This program comes with ABSOLUTELY NO WARRANTY; for details see /admin/version.php.
    This is free software, and you are welcome to redistribute it under certain conditions; see /admin/version.php for details.  */
include('checkuser.inc.php');
checkuser('root');
include('locale.inc.php');
$locale = new LocalizingClass('backup-action');
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
     "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title><?php locale('title_backup-unzip') ?></title>
<meta http-equiv="content-type" content="text/html; charset=utf-8" />
<link rel="stylesheet" type="text/css" href="style.css">
</head>
<body>
<?php
function updatePages() {
	include('./update/convert_pages_to_sections.inc.php');
	convert_pages_to_sections();
	include('urlindex.inc.php');
	generate_urlindex();
}

function updateStats() {
	if (file_exists('../data/stats/unknown.list')) {
		unlink('../data/stats/unknown.list');
	}
	$oldformat = false;
	$handle = opendir('../data/stats/browser');
	while (false !== ($file = readdir ($handle))) {
		if ($file != "." && $file != "..") {
			$contents = file_get_contents('../data/stats/browser/'.$file);
			if ($oldformat == true or substr_count($contents, "\n") != 2) {
				unlink('../data/stats/browser/'.$file);
				$oldformat = true;
			}
		}
	}
	closedir($handle);
	if ($oldformat == true) {
		$handle = opendir('../data/stats/os');
		while (false !== ($file = readdir ($handle))) {
			if ($file != "." && $file != "..") {
				unlink('../data/stats/os/'.$file);
			}
		}
		closedir($handle);
		if (file_exists('../data/stats/ip.list')) {
			unlink('../data/stats/ip.list');
		}
	}
}

function updateNeededFiles() {
	if (!file_exists('../data/settings/locale.inc.php')) {
		file_put_contents('../data/settings/locale.inc.php', '<?php
		$locale_default = "'.$_SESSION['CMS-Locale'].'";
		?>');
	}
	if (!is_dir('../data/counter')) {
		mkdir('../data/counter');
	}
	if (!is_dir('../data/files')) {
		mkdir('../data/files');
	}
	if (!is_dir('../data/includes')) {
		mkdir('../data/includes');
	}
	if (!is_dir('../data/recyclebin')) {
		mkdir('../data/recyclebin');
	}
	if (!is_dir('../data/recyclebin/files')) {
		mkdir('../data/recyclebin/files');
	}
	if (!is_dir('../data/recyclebin/includes')) {
		mkdir('../data/recyclebin/includes');
	}
	if (!is_dir('../data/recyclebin/pages')) {
		mkdir('../data/recyclebin/pages');
	}
	if (!is_dir('../data/stats')) {
		mkdir('../data/stats');
	}
	if (!is_dir('../data/stats/browser')) {
		mkdir('../data/stats/browser');
	}
	if (!is_dir('../data/stats/os')) {
		mkdir('../data/stats/os');
	}
	copy('./update/version.txt', '../data/version.php');
}


function delete_recursive($dir, $unlink_dir = false, $dontdelete = '') {
	if ($handle = opendir($dir)) {
		while (false !== ($file = readdir($handle))) {
			if($file != "." && $file != "..") {
				if (is_file($dir.'/'.$file)) {
					unlink($dir.'/'.$file);
				} elseif (is_dir($dir.'/'.$file) && $dontdelete != $dir.'/'.$file) {
					delete_recursive($dir.'/'.$file, true);
				}
			}
		}
		closedir($handle);
		if ($unlink_dir == true) {
			rmdir($dir);
		}
	}
}

function copy_recursive($src, $dest, $dontcopy = '') {
	if ($handle = opendir($src)) {
		if (!is_dir($dest)) {
			mkdir($dest);
		}
		while (false !== ($file = readdir($handle))) {
			if($file != "." && $file != "..") {
				if (is_file($src.'/'.$file)) {
					copy($src.'/'.$file, $dest.'/'.$file);
				} elseif (is_dir($src.'/'.$file) && $dontcopy != $src.'/'.$file) {
					copy_recursive($src.'/'.$file, $dest.'/'.$file);
				}
			}
		}
		closedir($handle);
	}
}

if (isset($_POST["submit"])) {
	
	echo '<h1>'.locale('title_backup-unzip',true).'</h1>';

	if (is_uploaded_file($_FILES["file"]["tmp_name"])) {
		
		if (substr($_FILES["file"]["name"], -4, 4) == '.zip') {
	
			if (copy($_FILES["file"]["tmp_name"], '../data/backup/'.$_FILES["file"]["name"])) {
			
				include("./pclzip-2-6/pclzip.lib.php");
				
				$zip = new PclZip('../data/backup/'.$_FILES["file"]["name"]);
				$prop = $zip->properties();
				if ($prop['status'] == 'ok') {
					
					$list = $zip->listContent();
					
					$signature = explode('/', $list[0]['filename']);
					$signature = $signature[0];
					
					if ($signature == 'cms-db_backup_pages_v0.4') {
						echo '<p>'.locale('desc_type',true).': '.locale('title_backup-pages',true).'</p>';
						$backup_directory = '../data/backup/extract_'.uniqid();
						copy_recursive('../data/pages', $backup_directory);
						delete_recursive('../data/pages');
						$result = $zip->extract(PCLZIP_OPT_PATH, '../data/pages',
							PCLZIP_OPT_REMOVE_PATH, $signature,
							PCLZIP_OPT_REPLACE_NEWER);
						if ($result == 0) {
							die('<p>'.locale('title_error',true).': '.$zip->errorInfo().'</p>');
							copy_recursive($backup_directory, '../data/pages');
							delete_recursive($backup_directory, true);
						}
						echo '<p>';
						for ($i=0; $i<sizeof($result); $i++) {
							echo 'extracting "'.$result[$i]['stored_filename'].'" to "'.$result[$i]['filename'].'" ... '.$result[$i]['status'].'<br />';
						}
						echo '</p>';
						delete_recursive($backup_directory, true);
						echo '<p>'.locale('desc_unzip-ready',true).'</p>';
						unlink('../data/backup/'.$_FILES["file"]["name"]);
						updatePages();
					} elseif ($signature == 'cms-db_backup_files_v0.4') {
						echo '<p>'.locale('desc_type',true).': '.locale('title_backup-files',true).'</p>';
						$backup_directory = '../data/backup/extract_'.uniqid();
						copy_recursive('../data/files', $backup_directory);
						delete_recursive('../data/files');
						$result = $zip->extract(PCLZIP_OPT_PATH, '../data/files',
							PCLZIP_OPT_REMOVE_PATH, $signature,
							PCLZIP_OPT_REPLACE_NEWER);
						if ($result == 0) {
							die('<p>'.locale('title_error',true).': '.$zip->errorInfo().'</p>');
							copy_recursive($backup_directory, '../data/files');
							delete_recursive($backup_directory, true);
						}
						echo '<p>';
						for ($i=0; $i<sizeof($result); $i++) {
							echo 'extracting "'.$result[$i]['stored_filename'].'" to "'.$result[$i]['filename'].'" ... '.$result[$i]['status'].'<br />';
						}
						echo '</p>';
						delete_recursive($backup_directory, true);
						echo '<p>'.locale('desc_unzip-ready',true).'</p>';
						unlink('../data/backup/'.$_FILES["file"]["name"]);
					} elseif ($signature == 'cms-db_backup_includes_v0.4') {
						echo '<p>'.locale('desc_type',true).': '.locale('title_backup-includes',true).'</p>';
						$backup_directory = '../data/backup/extract_'.uniqid();
						copy_recursive('../data/includes', $backup_directory);
						delete_recursive('../data/includes');
						$result = $zip->extract(PCLZIP_OPT_PATH, '../data/includes',
							PCLZIP_OPT_REMOVE_PATH, $signature,
							PCLZIP_OPT_REPLACE_NEWER);
						if ($result == 0) {
							die('<p>'.locale('title_error',true).': '.$zip->errorInfo().'</p>');
							copy_recursive($backup_directory, '../data/includes');
							delete_recursive($backup_directory, true);
						}
						echo '<p>';
						for ($i=0; $i<sizeof($result); $i++) {
							echo 'extracting "'.$result[$i]['stored_filename'].'" to "'.$result[$i]['filename'].'" ... '.$result[$i]['status'].'<br />';
						}
						echo '</p>';
						delete_recursive($backup_directory, true);
						echo '<p>'.locale('desc_unzip-ready',true).'</p>';
						unlink('../data/backup/'.$_FILES["file"]["name"]);
					} elseif ($signature == 'cms-db_backup_gb-tpl_v0.4') {
						echo '<p>'.locale('desc_type',true).': '.locale('title_backup-gb-tpl',true).'</p>';
						$result = $zip->extract(PCLZIP_OPT_PATH, '../data',
							PCLZIP_OPT_REMOVE_PATH, $signature,
							PCLZIP_OPT_REPLACE_NEWER);
						if ($result == 0) {
							die('<p>'.locale('title_error',true).': '.$zip->errorInfo().'</p>');
						}
						echo '<p>';
						for ($i=0; $i<sizeof($result); $i++) {
							echo 'extracting "'.$result[$i]['stored_filename'].'" to "'.$result[$i]['filename'].'" ... '.$result[$i]['status'].'<br />';
						}
						echo '</p>';
						echo '<p>'.locale('desc_unzip-ready',true).'</p>';
						unlink('../data/backup/'.$_FILES["file"]["name"]);
					} elseif ($signature == 'cms-db_backup_complete_v0.5') {
						echo '<p>'.locale('desc_type',true).': '.locale('title_backup-complete',true).'</p>';
						$backup_directory = '../data/backup/extract_'.uniqid();
						copy_recursive('../data', $backup_directory, '../data/backup');
						delete_recursive('../data', false, '../data/backup');
						$result = $zip->extract(PCLZIP_OPT_PATH, '../data',
							PCLZIP_OPT_REMOVE_PATH, $signature,
							PCLZIP_OPT_REPLACE_NEWER);
						if ($result == 0) {
							die('<p>'.locale('title_error',true).': '.$zip->errorInfo().'</p>');
							copy_recursive($backup_directory, '../data');
							delete_recursive($backup_directory, true);
						}
						echo '<p>';
						for ($i=0; $i<sizeof($result); $i++) {
							echo 'extracting "'.$result[$i]['stored_filename'].'" to "'.$result[$i]['filename'].'" ... '.$result[$i]['status'].'<br />';
						}
						echo '</p>';
						delete_recursive($backup_directory, true);
						echo '<p>'.locale('desc_unzip-ready',true).'</p>';
						unlink('../data/backup/'.$_FILES["file"]["name"]);
						updatePages();
						updateStats();
						updateNeededFiles();
					} else {
						echo '<p>'.locale('desc_unknown-format',true).'</p>';
						unlink('../data/backup/'.$_FILES["file"]["name"]);
					}
					echo '<p><a href="backup_unzip.php?'.SID.'">'.locale('link_back',true).'</a></p>';
					
				} else {
					echo '<p>'.locale('desc_archive-corrupt',true).' ('.locale('title_error',true).': '.$zip->errorInfo().')</p><p><a href="backup_unzip.php?'.SID.'">'.locale('link_back',true).'</a></p>';
					unlink('../data/backup/'.$_FILES["file"]["name"]);
				}
				
			} else {
				echo '<p>'.locale('desc_copy-error',true).'</p><p><a href="backup_unzip.php?'.SID.'">'.locale('link_back',true).'</a></p>';
			}
			
		} else {
			echo '<p>'.locale('desc_unknown-suffix',true).'</p><p><a href="backup_unzip.php?'.SID.'">'.locale('link_back',true).'</a></p>';
		}

	} else {
		echo '<p>'.locale('desc_no-file',true).'</p><p><a href="backup_unzip.php?'.SID.'">'.locale('link_back',true).'</a></p>';
	}

} else {
?>
<h1><?php locale('title_backup-unzip') ?></h1>
<p>
	<?php locale('desc_select-file') ?>
</p>
<p>
	<form action="backup_unzip.php?<?php echo SID ?>" method="post" enctype="multipart/form-data" name="upload">
	<input type="file" name="file"><br>
	<input type="submit" name="submit" value="<?php locale('button_upload-install') ?>">
	</form>
</p>
<p>
	<i>
		<?php locale('desc_overwritten-data') ?>
	</i>
</p>
<p>
	<i>
		<?php locale('desc_install-alternative') ?><br />
		<?php locale('title_backup-pages') ?>: /data/pages<br />
		<?php locale('title_backup-files') ?>: /data/files<br />
		<?php locale('title_backup-includes') ?>: /data/includes<br />
		<?php locale('title_backup-gb-tpl') ?>: /data<br />
		<?php locale('title_backup-complete') ?>: /data
	</i>
</p>
<p>
	<a href="backup.php?<?php echo SID ?>"><?php locale('link_back') ?></a>
</p>
<?php
}
?>
</body>
</html>
