<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<!--  cms-db  Copyright (C) 2007-2009 Jan Hoffmann
      This program comes with ABSOLUTELY NO WARRANTY; for details see /admin/version.php.
      This is free software, and you are welcome to redistribute it under certain conditions; see /admin/version.php for details.
      Additions:
        You are allowed to modify, and use this file (only this file) in the way you want.
        You should remove this comment if you don't want others to use or modify your template. -->
<html xmlns="http://www.w3.org/1999/xhtml">
	<head>
		<title>%%FULLTITLE%%</title>
		<meta http-equiv="Content-Type" content="text/html;charset=utf-8" />
		<style type="text/css">
		/* <![CDATA[ */
		@media all {
			body {
				font-family: Arial, Helvetica, sans-serif;
				background: #fff;
				color: #000;
			}
		}
		@media screen {
			body {
				font-size: 10.8pt; /* .9em */
			}
		}
		@media projection {
			body {
				font-size: 14.4pt; /* 1.2em */
			}
		}
		@media tv {
			body {
				font-size: 19.2pt; /* 1.6em */
			}
		}
		@media screen, projection, tv {
			html {
				padding: 0;
				margin: 0;
			}
			body {
				padding: 0 1em 0 1em;
				margin: 0;
			}
			#header {
				font-size: 1em;
				height: 3em;
				background: #cde1c0;
				margin: 1em -1em 0 -1em;
			}
			h1 {
				font-size: 2.5em; /* 2em */
				margin: 0 0 0 5.6em; /* 7em */
				line-height: 1.2em; /* 1.5em */
				font-weight: normal;
				padding: 0;
			}
			#container {
				margin: -3em auto 0 auto;
				min-width: 600px;
				max-width: 60em;
			}
			#menu-bg {
				width: 13em;
				background: #d1e2ff;
				position: fixed;
				top: 0;
				bottom: 0;
			}
			#left {
				float: left;
				width: 13em;
				margin-top: -3em;
				background: #d1e2ff;
				position: relative;
				z-index: 100;
			}
			#search {
				line-height: 3em;
				text-align: center;
				background: #accccf;
			}
			.search-input {
				width: 7em;
				background: #d1e2ff;
				border: 1px solid #8ca6a8;
				color: #4d5b5c;
			}
			.search-button {
				width: 4.5em;
				background: #dfdfdf;
				border: 1px solid #8ca6a8;
				color: #2f3738;
				cursor: pointer;
			}
			.search-button:hover {
				background: #eee;
				color: #4d5b5c;
			}
			#menu {
				margin: 1em 0 1em 0;
			}
			#menu ul {
				margin: 0;
				padding-left: 2em;
			}
			#menu ul ul {
				padding-left: 1em;
			}
			#content {
				margin-top: 0em;
				margin-left: 14em;
			}
			#footer {
				/* font-size: .9em; Für Opera */
				margin-top: -6em;
				text-align: center;
				/* width: 14.4em; Für Opera */
				width: 13em;
				padding: 1em 0 1em 0;
				background: #d1e2ff;
				position: relative;
				z-index: 99;
			}
			#footer * {
				font-size: 0.9em; /* Für Opera */
			}
			a:link, a:visited, a:active {
				color: #00f;
				text-decoration: none;
			}
			a:hover {
				text-decoration: underline;
			}
		}
		/* ]]> */
		</style>
		<!--[if IE 7]>
		<style type="text/css">
		/* <![CDATA[ */
		@media screen, projection, tv {
			#menu-bg {
				margin-left: -13em;
			}
			#footer {
				position: absolute;
				top: expression(document.body.scrollHeight);
				left: expression(document.getElementById("menu-bg").offsetLeft);
			}
		}
		/* ]]> */
		</style>
		<![endif]-->
		<!--[if lt IE 7]>
		<style type="text/css">
		/* <![CDATA[ */
		@media screen, projection, tv {
			body {
				height: 100%;
			}
			#menu-bg {
				position: absolute;
				top: 0;
				left: 1em;
				height: expression(document.body.clientHeight);
			}
			#search {
				height: 3em;
				overflow: hidden;
			}
			#search input {
				margin-top: .7em;
			}
			#footer {
				position: absolute;
				top: expression(document.body.clientHeight);
				left: 1em;
			}
		}
		/* ]]> */
		</style>
		<![endif]-->
	</head>
	<body>

		<div id="header"></div>
		<div id="container">
			<h1>Meine Website</h1>
			<div id="menu-bg"></div>
			<div id="left">
				<form action="%%URLABSOLUTE%%/index.php" method="get">
					<div id="search">
						<input type="hidden" name="special" value="search" />
						<input type="text" name="q" value="" size="10" maxlength="99" class="search-input" />
						<input type="submit" value="Suche" class="search-button" />
					</div>
				</form>
				<div id="menu">
					%%FOLDINGMENU%%
				</div>
			</div>
			<div id="content">
				<h2>%%PAGETITLE%%</h2>
				%%PAGECONTENT%%
			</div>
			<div id="footer">
				<a href="http://cms-db.de/">Powered by cms -db</a><br />
				<a href="http://validator.w3.org/check?uri=referer">Valid XHTML 1.0</a><br />
				<a href="http://jigsaw.w3.org/css-validator/check/referer">Valid CSS 2</a>
			</div>
		</div>

	</body>
</html>
